Statistics
| Branch: | Revision:

root / create @ d55a2cc1

History | View | Annotate | Download (5.3 kB)

1 79224631 Lance Albertson
#!/bin/bash
2 79224631 Lance Albertson
3 f1afb4b1 Lance Albertson
# Copyright (C) 2010 Oregon State University
4 79224631 Lance Albertson
#
5 79224631 Lance Albertson
# This program is free software; you can redistribute it and/or modify
6 79224631 Lance Albertson
# it under the terms of the GNU General Public License as published by
7 79224631 Lance Albertson
# the Free Software Foundation; either version 2 of the License, or
8 79224631 Lance Albertson
# (at your option) any later version.
9 79224631 Lance Albertson
#
10 79224631 Lance Albertson
# This program is distributed in the hope that it will be useful, but
11 79224631 Lance Albertson
# WITHOUT ANY WARRANTY; without even the implied warranty of
12 79224631 Lance Albertson
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
13 79224631 Lance Albertson
# General Public License for more details.
14 79224631 Lance Albertson
#
15 79224631 Lance Albertson
# You should have received a copy of the GNU General Public License
16 79224631 Lance Albertson
# along with this program; if not, write to the Free Software
17 79224631 Lance Albertson
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
18 79224631 Lance Albertson
# 02110-1301, USA.
19 79224631 Lance Albertson
20 79224631 Lance Albertson
set -e
21 79224631 Lance Albertson
22 6f0a1fef Lance Albertson
. common.sh
23 6f0a1fef Lance Albertson
24 e7a2d1ad Lance Albertson
debug set -x
25 e84e87cd Lance Albertson
26 5dc61974 Nikos Skalkotos
OS_FAMILY="linux"
27 5dc61974 Nikos Skalkotos
28 baca98f3 Lance Albertson
if [ "$IMAGE_TYPE" = "tarball" ] ; then
29 baca98f3 Lance Albertson
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}.tar.gz"
30 baca98f3 Lance Albertson
elif [ "$IMAGE_TYPE" = "qemu" ] ; then
31 baca98f3 Lance Albertson
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}.img"
32 640e7e45 Lance Albertson
elif [ "$IMAGE_TYPE" = "dump" ] ; then
33 640e7e45 Lance Albertson
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}-root.dump"
34 a33d2ab2 Nikos Skalkotos
elif [ "$IMAGE_TYPE" = "ntfsclone" ]; then
35 a33d2ab2 Nikos Skalkotos
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}.img"
36 a33d2ab2 Nikos Skalkotos
    OS_FAMILY="windows"
37 baca98f3 Lance Albertson
fi
38 134c11c3 Lance Albertson
39 58453ea9 Nikos Skalkotos
MONITOR="" #Empty if progress monitor support is disabled
40 d55a2cc1 Nikos Skalkotos
if [ "$progress_monitor_support" = "yes" ]; then
41 58453ea9 Nikos Skalkotos
    IMAGE_SIZE="$(stat -L -c %s ${IMAGE_FILE})"
42 58453ea9 Nikos Skalkotos
    MONITOR="$PROGRESS_MONITOR -i ${INSTANCE_NAME} -r ${IMAGE_SIZE}"
43 58453ea9 Nikos Skalkotos
fi
44 58453ea9 Nikos Skalkotos
45 a33d2ab2 Nikos Skalkotos
if [ "$OS_FAMILY" = "linux" ]; then
46 a33d2ab2 Nikos Skalkotos
    . common_linux.sh
47 a33d2ab2 Nikos Skalkotos
elif [ "$OS_FAMILY" = "windows" ]; then
48 a33d2ab2 Nikos Skalkotos
    . common_windows.sh
49 a33d2ab2 Nikos Skalkotos
    SWAP="no"
50 a33d2ab2 Nikos Skalkotos
fi
51 5dc61974 Nikos Skalkotos
52 fcce5224 Lance Albertson
if [ "$CDINSTALL" = "no" ] ; then
53 fcce5224 Lance Albertson
    # If the target device is not a real block device we'll first losetup it.
54 fcce5224 Lance Albertson
    # This is needed for file disks.
55 fcce5224 Lance Albertson
    if [ ! -b $blockdev ]; then
56 fcce5224 Lance Albertson
      ORIGINAL_BLOCKDEV=$blockdev
57 fcce5224 Lance Albertson
      blockdev=$($LOSETUP -sf $blockdev)
58 fcce5224 Lance Albertson
      CLEANUP+=("$LOSETUP -d $blockdev")
59 fcce5224 Lance Albertson
    fi
60 fcce5224 Lance Albertson
61 b05b1ab6 Lance Albertson
    if [ ! -f "$IMAGE_FILE" ] ; then
62 b05b1ab6 Lance Albertson
      log_error "Can't find image file: $IMAGE_FILE"
63 b05b1ab6 Lance Albertson
      exit 1
64 b05b1ab6 Lance Albertson
    fi
65 b05b1ab6 Lance Albertson
66 b05b1ab6 Lance Albertson
    # If the image is tarball based, then we need to manually create the
67 b05b1ab6 Lance Albertson
    # volumes, filesystems, etc
68 640e7e45 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" -o "${IMAGE_TYPE}" = "dump" ] ; then
69 b05b1ab6 Lance Albertson
        # Create 3 partitions, /boot, swap, & /
70 bb78ba49 Nikos Skalkotos
        ${OS_FAMILY}_format_disk0 $blockdev
71 b05b1ab6 Lance Albertson
    elif [ "${IMAGE_TYPE}" = "qemu" ] ; then
72 b05b1ab6 Lance Albertson
        # need a recent version of qemu for this
73 78422bb3 Lance Albertson
        ${QEMU_IMG} convert ${IMAGE_FILE} -O host_device ${blockdev} > /dev/null
74 a33d2ab2 Nikos Skalkotos
    elif [ "${IMAGE_TYPE}" = "ntfsclone" ] ; then
75 a33d2ab2 Nikos Skalkotos
        ${OS_FAMILY}_format_disk0 $blockdev
76 b05b1ab6 Lance Albertson
    fi
77 b05b1ab6 Lance Albertson
78 8727c57d Lance Albertson
    # deploying something like a windows image, skip the rest
79 8727c57d Lance Albertson
    if [ "${NOMOUNT}" = "yes" ] ; then
80 8727c57d Lance Albertson
      cleanup
81 8727c57d Lance Albertson
      exit 0
82 8727c57d Lance Albertson
    fi
83 8727c57d Lance Albertson
84 494927a8 Lance Albertson
    filesystem_dev=$(map_disk0 $blockdev)
85 a1d43218 Lance Albertson
    CLEANUP+=("unmap_disk0 $blockdev")
86 494927a8 Lance Albertson
    root_dev=$(map_partition $filesystem_dev root)
87 494927a8 Lance Albertson
    boot_dev=$(map_partition $filesystem_dev boot)
88 494927a8 Lance Albertson
    swap_dev=$(map_partition $filesystem_dev swap)
89 fcce5224 Lance Albertson
90 e9568fe9 Nikos Skalkotos
    # Check partition existence
91 e9568fe9 Nikos Skalkotos
    if [ ! -e "$root_dev" ] ; then
92 e9568fe9 Nikos Skalkotos
        log_error "Root partition: $root_dev does not exist!"
93 e9568fe9 Nikos Skalkotos
        exit 1;
94 e9568fe9 Nikos Skalkotos
    fi
95 025dd949 Nikos Skalkotos
    if [ -n "$boot_dev" -a ! -e "$boot_dev" ] ; then
96 e9568fe9 Nikos Skalkotos
        log_error "Boot partition: $boot_dev does not exist!"
97 e9568fe9 Nikos Skalkotos
        exit 1;
98 e9568fe9 Nikos Skalkotos
    fi
99 025dd949 Nikos Skalkotos
    if [ -n "$swap_dev" -a ! -e "$swap_dev" ] ; then
100 e9568fe9 Nikos Skalkotos
        log_error "Swap partiion: $swap_dev does not exist!"
101 e9568fe9 Nikos Skalkotos
        exit 1;
102 e9568fe9 Nikos Skalkotos
    fi
103 e9568fe9 Nikos Skalkotos
104 640e7e45 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" -o "${IMAGE_TYPE}" = "dump" ] ; then
105 bb78ba49 Nikos Skalkotos
        ${OS_FAMILY}_mkfs_disk0
106 3903b7f1 Lance Albertson
        root_uuid="$($VOL_ID $root_dev)"
107 b8a540bb Lance Albertson
        [ -n "$boot_dev" ] && sleep 1 && boot_uuid="$($VOL_ID $boot_dev)"
108 b8a540bb Lance Albertson
        [ -n "$swap_dev" ] && sleep 1 && swap_uuid="$($VOL_ID $swap_dev)"
109 b05b1ab6 Lance Albertson
    fi
110 fcce5224 Lance Albertson
111 916b6dd1 Lance Albertson
    TARGET=`mktemp -d` || exit 1
112 916b6dd1 Lance Albertson
    CLEANUP+=("rmdir $TARGET")
113 fcce5224 Lance Albertson
114 a33d2ab2 Nikos Skalkotos
    if [ "${IMAGE_TYPE}" = "ntfsclone" ] ; then
115 59aff5e7 Nikos Skalkotos
        # Restore the ntfs image
116 58453ea9 Nikos Skalkotos
        $MONITOR $NTFSCLONE --restore-image --overwrite $root_dev $IMAGE_FILE \
117 58453ea9 Nikos Skalkotos
            > /dev/null
118 59aff5e7 Nikos Skalkotos
        # Resize it to take over the whole patition
119 59aff5e7 Nikos Skalkotos
        $NTFSRESIZE -P $root_dev
120 59aff5e7 Nikos Skalkotos
121 a33d2ab2 Nikos Skalkotos
    fi
122 a33d2ab2 Nikos Skalkotos
123 a1d43218 Lance Albertson
    # mount filesystems
124 77449e7c Lance Albertson
    mount_disk0 $TARGET
125 b05b1ab6 Lance Albertson
126 b05b1ab6 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" ] ; then
127 b05b1ab6 Lance Albertson
        # unpack image
128 916b6dd1 Lance Albertson
        tar pzxf $IMAGE_FILE -C $TARGET
129 640e7e45 Lance Albertson
    elif [ "${IMAGE_TYPE}" = "dump" ] ; then
130 0d9031a6 Lance Albertson
        root_dump="${IMAGE_FILE}"
131 58453ea9 Nikos Skalkotos
        ( cd ${TARGET}; $MONITOR $RESTORE -r -y -f ${root_dump} > /dev/null )
132 77449e7c Lance Albertson
133 77449e7c Lance Albertson
        if [ -n "${boot_dev}" ] ; then
134 77449e7c Lance Albertson
            boot_dump="${IMAGE_FILE/root.dump/boot.dump}"
135 77449e7c Lance Albertson
            if [ ! -f "$boot_dump" ] ; then
136 77449e7c Lance Albertson
              log_error "Can't find image file: $boot_dump"
137 77449e7c Lance Albertson
              exit 1
138 77449e7c Lance Albertson
            fi
139 8afaedb3 Nikos Skalkotos
            ( cd ${TARGET}/boot; $RESTORE -r -y -f ${boot_dump} > /dev/null )
140 77449e7c Lance Albertson
        fi
141 b05b1ab6 Lance Albertson
    fi
142 e5ec11e4 Lance Albertson
143 3903b7f1 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" -o "${IMAGE_TYPE}" = "dump" ] ; then
144 bb78ba49 Nikos Skalkotos
        ${OS_FAMILY}_setup_fstab $TARGET
145 3903b7f1 Lance Albertson
    fi
146 3903b7f1 Lance Albertson
147 9f4b2c31 Lance Albertson
    if [ "${INSTANCE_HV_serial_console}" = "True" ] ; then
148 bb78ba49 Nikos Skalkotos
        ${OS_FAMILY}_setup_console $TARGET
149 9f4b2c31 Lance Albertson
    fi
150 9f4b2c31 Lance Albertson
151 86ddc018 Nikos Skalkotos
    ${OS_FAMILY}_epilogue $TARGET
152 47e547ca Nikos Skalkotos
153 fcce5224 Lance Albertson
    RUN_PARTS=`which run-parts`
154 fcce5224 Lance Albertson
155 bb78ba49 Nikos Skalkotos
    if [ -n "$RUN_PARTS" -a -n "$CUSTOMIZE_DIR" -a -d "${CUSTOMIZE_DIR}/$OS_FAMILY" ]; then
156 916b6dd1 Lance Albertson
      TARGET=$TARGET
157 fcce5224 Lance Albertson
      BLOCKDEV=$blockdev
158 f7959feb Lance Albertson
      ROOT_DEV=$root_dev
159 c29e092d Lance Albertson
      BOOT_DEV=$boot_dev
160 ab462591 Constantinos Venetsanopoulos
      IMG_PASSWD=$IMG_PASSWD
161 8d77389f Nikos Skalkotos
      HOSTNAME=$instance
162 8d77389f Nikos Skalkotos
      export TARGET SUITE BLOCKDEV ROOT_DEV BOOT_DEV IMAGE_TYPE IMG_PASSWD HOSTNAME
163 bb78ba49 Nikos Skalkotos
      $RUN_PARTS $CUSTOMIZE_DIR/$OS_FAMILY
164 fcce5224 Lance Albertson
    fi
165 79224631 Lance Albertson
fi
166 79224631 Lance Albertson
167 79224631 Lance Albertson
# execute cleanups
168 79224631 Lance Albertson
cleanup
169 79224631 Lance Albertson
trap - EXIT
170 79224631 Lance Albertson
171 79224631 Lance Albertson
exit 0